Wed Aug 21 15:50:54 1996 Martin M. Hunt <hunt@pizza.cygnus.com>
[deliverable/binutils-gdb.git] / configure.in
1 #! /bin/bash
2 ##############################################################################
3
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
8
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
13
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
16
17 # Copyright (C) 1992, 93, 94, 95, 1996 Free Software Foundation, Inc.
18 #
19 # This file is free software; you can redistribute it and/or modify it
20 # under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
23 #
24 # This program is distributed in the hope that it will be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27 # General Public License for more details.
28 #
29 # You should have received a copy of the GNU General Public License
30 # along with this program; if not, write to the Free Software
31 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
32
33 ##############################################################################
34
35 ### To add a new directory to the tree, first choose whether it is a target
36 ### or a host dependent tool. Then put it into the appropriate list
37 ### (library or tools, host or target), doing a dependency sort. For
38 ### example, gdb requires that byacc (or bison) be built first, so it is in
39 ### the ${host_tools} list after byacc and bison.
40
41
42 # these libraries are used by various programs built for the host environment
43 #
44 host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
45
46 if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
48 fi
49
50 # these tools are built for the host environment
51 #
52 host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch
53 prms send-pr gprof gdbtest tgas etc expect dejagnu sim bash
54 m4 autoconf ispell grep diff rcs cvs fileutils shellutils time
55 textutils wdiff find emacs emacs19 uudecode hello tar gzip indent
56 recode release sed utils guile perl apache inet gawk"
57
58
59 # these libraries are built for the target environment, and are built after
60 # the host libraries and the host tools (which may be a cross compiler)
61 #
62 target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
63
64
65 # these tools are built using the target libs, and are intended to run only
66 # in the target environment
67 #
68 # note: any program that *uses* libraries that are in the "target_libs"
69 # list belongs in this list. those programs are also very likely
70 # candidates for the "native_only" list which follows
71 #
72 target_tools="target-examples target-groff"
73
74 ################################################################################
75
76 ## These two lists are of directories that are to be removed from the
77 ## ${configdirs} list for either cross-compilations or for native-
78 ## compilations. For example, it doesn't make that much sense to
79 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
80 ## a native environment.
81
82 # directories to be built in the native environment only
83 #
84 native_only="autoconf cvs emacs emacs19 fileutils find gawk grep gzip hello
85 indent ispell m4 rcs recode sed shellutils tar textutils gash
86 uudecode wdiff gprof target-groff guile perl apache inet time
87 bash prms"
88
89 # directories to be built in a cross environment only
90 #
91 cross_only="target-libiberty target-libgloss target-newlib"
92
93 ## All tools belong in one of the four categories, and are assigned above
94 ## We assign ${configdirs} this way to remove all embedded newlines. This
95 ## is important because configure will choke if they ever get through.
96 ## ${configdirs} is directories we build using the host tools.
97 ## ${target_configdirs} is directories we build using the target tools.
98 #
99 configdirs=`echo ${host_libs} ${host_tools}`
100 target_configdirs=`echo ${target_libs} ${target_tools}`
101
102 ################################################################################
103
104 srctrigger=move-if-change
105 srcname="gnu development package"
106
107 # This gets set non-empty for some net releases of packages.
108 appdirs=""
109
110 # per-host:
111
112 # Work in distributions that contain no compiler tools, like Autoconf.
113 if [ -d ${srcdir}/config ]; then
114 case "${host}" in
115 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
116 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
117 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
118 m68k-*-linux*) host_makefile_frag=config/mh-linux ;;
119 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
120 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
121 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
122 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
123 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
124 mips*-sgi-irix6*) host_makefile_frag=config/mh-irix6 ;;
125 mips*-sgi-irix5*) host_makefile_frag=config/mh-irix5 ;;
126 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
127 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
128 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
129 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
130 i[345]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
131 i[345]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
132 i[345]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
133 i[345]86-*-sco*) host_makefile_frag=config/mh-sco ;;
134 i[345]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
135 i[345]86-*-linux*) host_makefile_frag=config/mh-linux ;;
136 i[345]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
137 i[345]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
138 i[345]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
139 *-cygwin32*) host_makefile_frag=config/mh-cygwin32 ;;
140 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
141 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
142 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
143 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
144 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
145 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
146 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
147 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
148 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
149 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
150 esac
151 fi
152
153 # If we aren't going to be using gcc, see if we can extract a definition
154 # of CC from the fragment.
155 if [ -z "${CC}" -a "${build}" = "${host}" ]; then
156 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
157 found=
158 for dir in $PATH; do
159 test -z "$dir" && dir=.
160 if test -f $dir/gcc; then
161 found=yes
162 break
163 fi
164 done
165 IFS="$save_ifs"
166 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
167 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
168 if [ -n "${xx}" ] ; then
169 CC=$xx
170 fi
171 fi
172 fi
173
174 # We default to --with-shared on platforms where -fpic is meaningless.
175 # Well, we don't yet, but we will.
176 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
177 case "${target}" in
178 alpha-dec-osf*) enable_shared=yes ;;
179 alpha-*-linux*) enable_shared=yes ;;
180 mips-sgi-irix5*) enable_shared=yes ;;
181 *) enable_shared=no ;;
182 esac
183 fi
184
185 case "${enable_shared}" in
186 yes) shared=yes ;;
187 no) shared=no ;;
188 "") shared=no ;;
189 *) shared=yes ;;
190 esac
191
192 if [ x${shared} = xyes ]; then
193 waugh=
194 case "${host}" in
195 hppa*) waugh=config/mh-papic ;;
196 i[345]86-*) waugh=config/mh-x86pic ;;
197 sparc64-*) waugh=config/mh-sparcpic ;;
198 *) waugh=config/mh-${host_cpu}pic ;;
199 esac
200 if [ -f ${srcdir}/${waugh} ]; then
201 if [ -n "${host_makefile_frag}" ] ; then
202 cat ${srcdir}/${host_makefile_frag} > mh-frag
203 cat ${srcdir}/${waugh} >> mh-frag
204 host_makefile_frag=mh-frag
205 else
206 host_makefile_frag=${waugh}
207 fi
208 fi
209 fi
210
211 # per-target:
212
213 case "${target}" in
214 v810*) target_makefile_frag=config/mt-v810 ;;
215 i[345]86-*-netware*) target_makefile_frag=config/mt-netware ;;
216 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
217 powerpc*-*-eabi* | \
218 powerpc*-*-elf* | \
219 powerpc*-*-linux* | \
220 powerpc*-*-rtem* | \
221 powerpc*-*-sysv* | \
222 powerpc*-*-solaris*) target_makefile_frag=config/mt-ppc ;;
223 esac
224
225 skipdirs=
226 gasdir=gas
227 use_gnu_ld=
228 use_gnu_as=
229
230 # some tools are so dependent upon X11 that if we're not building with X,
231 # it's not even worth trying to configure, much less build, that tool.
232
233 case ${with_x} in
234 yes | "") # the default value for this tree is that X11 is available
235 ;;
236 no)
237 skipdirs="${skipdirs} tk gash"
238 ;;
239 *)
240 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
241 ;;
242 esac
243
244 # Some tools are only suitable for building in a "native" situation.
245 # Those are added when we have a host==target configuration. For cross
246 # toolchains, we add some directories that should only be useful in a
247 # cross-compiler.
248
249 is_cross_compiler=
250
251 if [ x"${host}" = x"${target}" ] ; then
252 # when doing a native toolchain, don't build the targets
253 # that are in the 'cross only' list
254 skipdirs="${skipdirs} ${cross_only}"
255 is_cross_compiler=no
256 target_subdir=.
257 else
258 # similarly, don't build the targets in the 'native only'
259 # list when building a cross compiler
260 skipdirs="${skipdirs} ${native_only}"
261 is_cross_compiler=yes
262 target_subdir=${target_alias}
263 if [ ! -d ${target_subdir} ] ; then
264 if mkdir ${target_subdir} ; then true
265 else
266 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
267 exit 1
268 fi
269 fi
270 fi
271
272 copy_dirs=
273
274 # Handle --with-headers=XXX. The contents of the named directory are
275 # copied to $(tooldir)/sys-include.
276 if [ x"${with_headers}" != x ]; then
277 if [ x${is_cross_compiler} = xno ]; then
278 echo 1>&2 '***' --with-headers is only supported when cross compiling
279 exit 1
280 fi
281 case "${exec_prefixoption}" in
282 "") x=${prefix} ;;
283 *) x=${exec_prefix} ;;
284 esac
285 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
286 fi
287
288 # Handle --with-libs=XXX. Multiple directories are permitted. The
289 # contents are copied to $(tooldir)/lib.
290 if [ x"${with_libs}" != x ]; then
291 if [ x${is_cross_compiler} = xno ]; then
292 echo 1>&2 '***' --with-libs is only supported when cross compiling
293 exit 1
294 fi
295 # Copy the libraries in reverse order, so that files in the first named
296 # library override files in subsequent libraries.
297 case "${exec_prefixoption}" in
298 "") x=${prefix} ;;
299 *) x=${exec_prefix} ;;
300 esac
301 for l in ${with_libs}; do
302 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
303 done
304 fi
305
306 # If both --with-headers and --with-libs are specified, default to
307 # --without-newlib.
308 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
309 if [ x"${with_newlib}" = x ]; then
310 with_newlib=no
311 fi
312 fi
313
314 # Recognize --with-newlib/--without-newlib.
315 if [ x${with_newlib} = xno ]; then
316 skipdirs="${skipdirs} target-newlib"
317 elif [ x${with_newlib} = xyes ]; then
318 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
319 fi
320
321 # Default to using --with-stabs for certain targets.
322 if [ x${with_stabs} = x ]; then
323 case "${target}" in
324 mips*-*-* | alpha*-*-osf* | i[345]86*-*-sysv4* | i[345]86*-*-unixware*)
325 with_stabs=yes;
326 withoptions="${withoptions} --with-stabs"
327 ;;
328 esac
329 fi
330
331 # Handle ${copy_dirs}
332 set fnord ${copy_dirs}
333 shift
334 while [ $# != 0 ]; do
335 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
336 :
337 else
338 echo Copying $1 to $2
339
340 # Use the install script to create the directory and all required
341 # parent directories.
342 if [ -d $2 ]; then
343 :
344 else
345 echo >config.temp
346 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
347 fi
348
349 # Copy the directory, assuming we have tar.
350 # FIXME: Should we use B in the second tar? Not all systems support it.
351 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
352
353 # It is the responsibility of the user to correctly adjust all
354 # symlinks. If somebody can figure out how to handle them correctly
355 # here, feel free to add the code.
356
357 echo $1 > $2/COPIED
358 fi
359 shift; shift
360 done
361
362 # Configure extra directories which are host specific
363
364 case "${host}" in
365 i[345]86-*-go32*)
366 configdirs="$configdirs dosrel" ;;
367 *-cygwin32*)
368 configdirs="$configdirs dosrel" ;;
369 esac
370
371 # Remove more programs from consideration, based on the host or
372 # target this usually means that a port of the program doesn't
373 # exist yet.
374
375 noconfigdirs=""
376
377 case "${host}" in
378 i[345]86-*-vsta)
379 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
380 ;;
381 i[345]86-*-go32)
382 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
383 ;;
384 *-*-cygwin32)
385 noconfigdirs="tk tcl expect dejagnu cvs autoconf bison send-pr gprof rcs guile perl texinfo apache inet"
386 ;;
387 ppc*-*-pe)
388 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
389 ;;
390 esac
391
392
393 case "${target}" in
394 *-*-netware)
395 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
396 ;;
397 *-*-vxworks*)
398 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
399 ;;
400 alpha-dec-osf*)
401 # ld works, but does not support shared libraries. emacs doesn't
402 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
403 # gas doesn't generate exception information.
404 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib target-libgloss"
405 ;;
406 alpha*-*-*vms*)
407 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
408 ;;
409 alpha*-*-*)
410 # newlib is not 64 bit ready
411 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
412 ;;
413 # start-sanitize-arc
414 arc-*-*)
415 noconfigdirs="$noconfigdirs target-libgloss"
416 ;;
417 # end-sanitize-arc
418 arm-*-pe*)
419 noconfigdirs="$noconfigdirs target-libgloss"
420 ;;
421 arm-*-riscix*)
422 noconfigdirs="$noconfigdirs ld target-libgloss"
423 ;;
424 # start-sanitize-d10v
425 d10v-*-*)
426 noconfigdirs="$noconfigdirs gdb target-libgloss"
427 ;;
428 # end-sanitize-d10v
429 h8300*-*-* | \
430 h8500-*-*)
431 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
432 ;;
433 hppa*-*-*elf* | \
434 hppa*-*-lites*)
435 # Do configure ld/binutils/gas for this case.
436 ;;
437 hppa*-*-*)
438 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
439 # cc is gcc, and on any system a user should be able to link cc to
440 # whatever they want. FIXME, emacs emacs19).
441 case "${CC}" in
442 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
443 *) ;;
444 esac
445 noconfigdirs="$noconfigdirs ld shellutils"
446 ;;
447 i[345]86-*-go32)
448 # but don't build gdb
449 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
450 ;;
451 *-*-cygwin32)
452 target_configdirs="$target_configdirs target-winsup"
453 noconfigdirs="$noconfigdirs tcl tk expect target-libgloss"
454 # always build newlib.
455 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
456
457 # Can't build gdb for cygwin32 if not native.
458 case "${host}" in
459 *-*-cygwin32) ;; # keep gdb
460 *) noconfigdirs="$noconfigdirs gdb"
461 esac
462 ;;
463 i[345]86-*-pe)
464 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
465 ;;
466 i[345]86-*-sco3.2v5*)
467 # The linker does not yet know about weak symbols in COFF,
468 # and is not configured to handle mixed ELF and COFF.
469 noconfigdirs="$noconfigdirs gprof ld target-libgloss"
470 ;;
471 i[345]86-*-sco*)
472 noconfigdirs="$noconfigdirs gprof target-libgloss"
473 ;;
474 i[345]86-*-solaris2*)
475 # The linker does static linking correctly, but the Solaris C library
476 # has bugs such that some important functions won't work when statically
477 # linked. (See man pages for getpwuid, for example.)
478 noconfigdirs="$noconfigdirs ld target-libgloss"
479 ;;
480 i[345]86-*-sysv4*)
481 # The SYSV4 C compiler doesn't handle Emacs correctly
482 case "${CC}" in
483 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
484 *) ;;
485 esac
486 # but that's okay since emacs doesn't work anyway
487 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
488 ;;
489 powerpc-*-aix*)
490 # copied from rs6000-*-* entry
491 noconfigdirs="$noconfigdirs gprof cvs target-libgloss"
492 # This is needed until gcc and ld are fixed to work together.
493 use_gnu_ld=no
494 ;;
495 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
496 target_configdirs="$target_configdirs target-winsup"
497 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss"
498 # always build newlib.
499 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
500 ;;
501 # This is temporary until we can link against shared libraries
502 powerpcle-*-solaris*)
503 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect"
504 ;;
505 rs6000-*-lynxos*)
506 # The CVS server code doesn't work on the RS/6000
507 # Newlib makes problems for libg++ in crosses.
508 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
509 ;;
510 rs6000-*-aix*)
511 noconfigdirs="$noconfigdirs gprof"
512 # This is needed until gcc and ld are fixed to work together.
513 use_gnu_ld=no
514 ;;
515 rs6000-*-*)
516 noconfigdirs="$noconfigdirs gprof"
517 ;;
518 m68k-apollo-*)
519 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
520 ;;
521 mips*-*-irix5*)
522 # The GNU linker does not support shared libraries.
523 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
524 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
525 ;;
526 mips*-*-irix6*)
527 # The GNU linker does not support shared libraries.
528 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
529 # BFD does not have Irix 6 support yet.
530 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes gdb readline mmalloc sim gprof emacs target-libgloss"
531 ;;
532 mips*-dec-bsd*)
533 noconfigdirs="$noconfigdirs gprof target-libgloss"
534 ;;
535 mips*-*-bsd*)
536 noconfigdirs="$noconfigdirs gprof target-libgloss"
537 ;;
538 mips*-*-*)
539 noconfigdirs="$noconfigdirs gprof"
540 ;;
541 romp-*-*)
542 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
543 ;;
544 sh-*-*)
545 case "${host}" in
546 i[345]86-*-vsta) ;; # don't add gprof back in
547 i[345]86-*-go32) ;; # don't add gprof back in
548 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
549 esac
550 noconfigdirs="$noconfigdirs target-libgloss"
551 ;;
552 sparc-*-sunos4*)
553 if [ x${is_cross_compiler} != xno ] ; then
554 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
555 else
556 use_gnu_ld=no
557 fi
558 ;;
559 v810-*-*)
560 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
561 ;;
562 v850-*-*)
563 noconfigdirs="$noconfigdirs gdb ld target-libio target-libg++ target-libstdc++ target-libgloss"
564 ;;
565 vax-*-vms)
566 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
567 ;;
568 vax-*-*)
569 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
570 ;;
571 *-*-lynxos*)
572 # Newlib makes problems for libg++ in crosses.
573 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
574 ;;
575 *-*-macos* | \
576 *-*-mpw*)
577 # Macs want a resource compiler.
578 configdirs="$configdirs grez"
579 ;;
580 esac
581
582 # targets that need a second pass
583 case "${target}" in
584 *-gm-magic*)
585 noconfigdirs="$noconfigdirs target-libgloss"
586 ;;
587 esac
588
589 # If we aren't building newlib, then don't build libgloss, since libgloss
590 # depends upon some newlib header files.
591 case "${noconfigdirs}" in
592 *target-libgloss*) ;;
593 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
594 esac
595
596 # If we are building a Canadian Cross, discard tools that can not be built
597 # using a cross compiler. FIXME: These tools should be fixed.
598 if [ "${build}" != "${host}" ]; then
599 noconfigdirs="$noconfigdirs tcl tk expect dejagnu"
600 fi
601
602 # Make sure we don't let GNU ld be added if we didn't want it.
603 if [ x$with_gnu_ld = xno ]; then
604 use_gnu_ld=no
605 noconfigdirs="$noconfigdirs ld"
606 fi
607
608 # Make sure we don't let GNU as be added if we didn't want it.
609 if [ x$with_gnu_as = xno ]; then
610 use_gnu_as=no
611 noconfigdirs="$noconfigdirs gas"
612 fi
613
614 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
615 # $target_configdirs.
616 # If we have the source for $noconfigdirs entries, add them to $notsupp.
617
618 notsupp=""
619 for dir in . $skipdirs $noconfigdirs ; do
620 dirname=`echo $dir | sed -e s/target-//g`
621 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
622 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
623 if [ -r $srcdir/$dirname/configure ] \
624 || [ -r $srcdir/$dirname/configure.in ]; then
625 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
626 true
627 else
628 notsupp="$notsupp $dir"
629 fi
630 fi
631 fi
632 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
633 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
634 if [ -r $srcdir/$dirname/configure ] \
635 || [ -r $srcdir/$dirname/configure.in ]; then
636 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
637 true
638 else
639 notsupp="$notsupp $dir"
640 fi
641 fi
642 fi
643 done
644
645 # Sometimes the tools are distributed with libiberty but with no other
646 # libraries. In that case, we don't want to build target-libiberty.
647 if [ -n "${target_configdirs}" ]; then
648 others=
649 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
650 if [ "$i" != "libiberty" ]; then
651 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
652 others=yes;
653 break;
654 fi
655 fi
656 done
657 if [ -z "${others}" ]; then
658 target_configdirs=
659 fi
660 fi
661
662 # Deconfigure all subdirectories, in case we are changing the
663 # configuration from one where a subdirectory is supported to one where it
664 # is not.
665 if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
666 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
667 rm -f $i/Makefile
668 done
669 fi
670 if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
671 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
672 rm -f ${target_subdir}/$i/Makefile
673 done
674 fi
675
676 # Produce a warning message for the subdirs we can't configure.
677 # This isn't especially interesting in the Cygnus tree, but in the individual
678 # FSF releases, it's important to let people know when their machine isn't
679 # supported by the one or two programs in a package.
680
681 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
682 # If $appdirs is non-empty, at least one of those directories must still
683 # be configured, or we error out. (E.g., if the gas release supports a
684 # specified target in some subdirs but not the gas subdir, we shouldn't
685 # pretend that all is well.)
686 if [ -n "$appdirs" ]; then
687 for dir in $appdirs ; do
688 if [ -r $dir/Makefile.in ]; then
689 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
690 appdirs=""
691 break
692 fi
693 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
694 appdirs=""
695 break
696 fi
697 fi
698 done
699 if [ -n "$appdirs" ]; then
700 echo "*** This configuration is not supported by this package." 1>&2
701 exit 1
702 fi
703 fi
704 # Okay, some application will build, or we don't care to check. Still
705 # notify of subdirs not getting built.
706 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
707 echo " ${notsupp}" 1>&2
708 echo " (Any other directories should still work fine.)" 1>&2
709 fi
710
711 # Set with_gnu_as and with_gnu_ld as appropriate.
712 #
713 # This is done by determining whether or not the appropriate directory
714 # is available, and by checking whether or not specific configurations
715 # have requested that this magic not happen.
716 #
717 # The command line options always override the explicit settings in
718 # configure.in, and the settings in configure.in override this magic.
719 #
720 # If the default for a toolchain is to use GNU as and ld, and you don't
721 # want to do that, then you should use the --without-gnu-as and
722 # --without-gnu-ld options for the configure script.
723
724 if [ x${use_gnu_as} = x ] ; then
725 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
726 with_gnu_as=yes
727 withoptions="$withoptions --with-gnu-as"
728 fi
729 fi
730
731 if [ x${use_gnu_ld} = x ] ; then
732 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
733 with_gnu_ld=yes
734 withoptions="$withoptions --with-gnu-ld"
735 fi
736 fi
737
738 if [ x${shared} = xyes ]; then
739 case "${target}" in
740 hppa*) target_makefile_frag=config/mt-papic ;;
741 i[345]86-*) target_makefile_frag=config/mt-x86pic ;;
742 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
743 esac
744 fi
745
746 # post-target:
747
748 # Make sure that the compiler is able to generate an executable. If it
749 # can't, we are probably in trouble. We don't care whether we can run the
750 # executable--we might be using a cross compiler--we only care whether it
751 # can be created. At this point the main configure script has set CC.
752 echo "int main () { return 0; }" > conftest.c
753 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
754 if [ $? = 0 ] && [ -s conftest ]; then
755 :
756 else
757 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
758 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
759 rm -f conftest*
760 exit 1
761 fi
762 rm -f conftest*
763
764 # The Solaris /usr/ucb/cc compiler does not appear to work.
765 case "${host}" in
766 sparc-sun-solaris2*)
767 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
768 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
769 could_use=
770 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
771 if [ -d /opt/cygnus/bin ] ; then
772 if [ "$could_use" = "" ] ; then
773 could_use="/opt/cygnus/bin"
774 else
775 could_use="$could_use or /opt/cygnus/bin"
776 fi
777 fi
778 if [ "$could_use" = "" ] ; then
779 echo "Warning: compilation may fail because you're using"
780 echo "/usr/ucb/cc. You should change your PATH or CC "
781 echo "variable and rerun configure."
782 else
783 echo "Warning: compilation may fail because you're using"
784 echo "/usr/ucb/cc, when you should use the C compiler from"
785 echo "$could_use. You should change your"
786 echo "PATH or CC variable and rerun configure."
787 fi
788 fi
789 ;;
790 esac
791
792 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
793 # binutils tools will find libbfd.so.
794 if [ "${shared}" = "yes" ]; then
795 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
796 Makefile > Makefile.tem
797 rm -f Makefile
798 mv -f Makefile.tem Makefile
799
800 case "${host}" in
801 *-*-hpux*)
802 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
803 Makefile > Makefile.tem
804 rm -f Makefile
805 mv -f Makefile.tem Makefile
806 ;;
807 esac
808 fi
809
810 # Record target_configdirs and the configure arguments in Makefile.
811 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
812 targargs=`echo "${arguments}" | \
813 sed -e 's/--norecursion//' \
814 -e 's/--cache[a-z-]*=[^ ]*//' \
815 -e 's/--ho[a-z-]*=[^ ]*//' \
816 -e 's/--ta[a-z-]*=[^ ]*//'`
817
818 # Passing a --with-cross-host argument lets the target libraries know
819 # whether they are being built with a cross-compiler or being built
820 # native. However, it would be better to use other mechanisms to make the
821 # sorts of decisions they want to make on this basis. Please consider
822 # this option to be deprecated. FIXME.
823 if [ x${is_cross_compiler} = xyes ]; then
824 targargs="--with-cross-host=${host_alias} ${targargs}"
825 fi
826
827 targargs="--host=${target_alias} ${targargs}"
828 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
829 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
830 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
831 Makefile > Makefile.tem
832 rm -f Makefile
833 mv -f Makefile.tem Makefile
834
835 #
836 # Local Variables:
837 # fill-column: 131
838 # End:
839 #
This page took 0.089231 seconds and 4 git commands to generate.